module sound (

	// inputs
	input clk,
	input reg enable,
	
	// outputs
	output reg speaker
	
);

reg [22:0] 	tone;
reg [15:0] 	counter;

wire [6:0] 	ramp 			= (tone[22] ? tone[21:15] : ~tone[21:15]);
wire [15:0] clkdivider 	= {1'b0, ramp, 8'b00000000};

always @(posedge clk) begin

	if (enable) begin
	
		tone 	<= tone + 1;
	
		if (counter==0) begin
		
			speaker 	<= ~speaker;
			counter 	<= clkdivider;
		
		end
		else begin
		
			counter 	<= counter - 1;
		
		end
		
	end
 
end

endmodule
